﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace CSharpSample
{
    public partial class ExtractFolder : Form
    {
        public ExtractFolder()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.SelectedPath = Path.GetDirectoryName(Application.ExecutablePath);
            if (folderBrowserDialog1.ShowDialog(this) == DialogResult.OK)
                txtSource.Text = folderBrowserDialog1.SelectedPath;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                txtDestination.Text = folderBrowserDialog1.SelectedPath;
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            bool boolSource, boolDest;
            boolSource = sourceValidation();
            boolDest = destinationValidation();
            if (boolDest && boolSource)
                this.DialogResult = DialogResult.OK;

        }

        private bool sourceValidation()
        {
            if (txtSource.Text.Trim() == string.Empty)
            {
                errorProvider1.SetError(txtSource, "Please select source path");
                return false;
            }
            return true;
        }

        private bool destinationValidation()
        {
            if (txtDestination.Text.Trim() == string.Empty)
            {
                errorProvider2.SetError(txtDestination, "Please select destination path");
                return false;
            }
            return true;
        }
    }
}
